/*
plucache.cpp 
Copyright (C) 2001  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#ifndef _PLU_CACHE_
#define _PLU_CACHE_

#include <list>
#include <algorithm>

class PluCacheItem{
private:
   bool   bEphemeral;
	char	 Plu[32];
	char	 displayText[64];
	char	 recuText[32];
   int    nameID;
   int    productID;
	int    promoID;
	double tax;
	double discount;  // fixed discount
	int    deposittype;
	double deposit;
	double unitPrice;
	int	 flags;
	
public:	
	PluCacheItem();
   PluCacheItem(PluCacheItem const&);
	~PluCacheItem();
   PluCacheItem &operator=(const PluCacheItem&);

	void   Clear();
	void   SetPLU(char *);
   void   SetProductID(int);
   void   SetNameID(int);
	void   SetDispText(char *);
	void   SetRecText(char *);
	void   SetPromoID(int);
	void   SetTax(double);
	void   SetDepositType(int);
	void   SetDeposit(double);
	void   SetDiscount(double);
	void   SetPrice(double);
	void   SetFlags(int);
	void   SetEphemeral(bool);
	char  *GetPlu();
   int	 GetProductID();
   int    GetNameID();
	char  *GetDispText();
	char  *GetRecuText();
	int	 GetPromoID();
	double GetTax();
	double GetDiscount();
	int    GetDepositType();
   double GetDeposit();
	double GetPrice();
	int    GetFlags();
	bool   GetEphemeral();
   //bool   operator==(const char *p);
	bool   operator==(const PluCacheItem&);
	bool   operator!=(const PluCacheItem&);
   bool   operator<(const PluCacheItem&);	
};

class CPluCache{
private:
	std::list<PluCacheItem> cache;
	
public:
	CPluCache();
	~CPluCache();
	bool Load(bhpos::BhSQL *);
	bool Reload(bhpos::BhSQL *, int cache_limit, char *precache);
	bool Add(PluCacheItem& p);
	bool Remove(PluCacheItem& p);
	bool Replace(PluCacheItem& r);
	bool Find(PluCacheItem& r);		
};


#endif	// _PLU_CACHE_
