#ifndef __BHSQL_VALUES__
#define __BHSQL_VALUES__

#include "../config.h"

// old enum values
#define SQL_LIENUM_DATA            0
#define SQL_LIENUM_PTR             1
#define SQL_LIENUM_PAIR            2

// post action values
#define SQL_P_CONNECT              1
#define SQL_P_CONNECTFAIL          2
#define SQL_P_CONNECTREFUSE        3
#define SQL_P_DISCONNECT           4
#define SQL_P_STANDBY              5
#define SQL_P_SHUTDOWN             6
#define SQL_P_USERLOGIN            7
#define SQL_P_USERLOGINREFUSE      8
#define SQL_P_USERLOGOUT           9
#define SQL_P_USERLOGOUTREFUSE     10
#define SQL_P_SUPERLOGIN           11
#define SQL_P_SUPERLOGINREFUSE     12
#define SQL_P_SUPERLOGOUT          13
#define SQL_P_MANAGERLOGIN         14
#define SQL_P_MANAGERLOGINREFUSE   15
#define SQL_P_MANAGERLOGOUT        16
#define SQL_P_ADMINLOGIN           17
#define SQL_P_ADMINLOGINREFUSE     18
#define SQL_P_ADMINLOGOUT          19
#define SQL_P_DISCONNECTREFUSE     20
#define SQL_P_NOSALE               21
#define SQL_P_VOIDSALE             22
#define SQL_P_BLINDBALANCE         23
#define SQL_P_BLINDBALANCEDISCREP  24

// user action values
#define SQL_U_CLOCKIN              1
#define SQL_U_CLOCKOUT             2
#define SQL_U_LOGIN                3
#define SQL_U_LOGOUT               4
#define SQL_U_WEBLOGIN             5
#define SQL_U_WEBLOGOUT            6
#define SQL_U_MISLOGIN             7
#define SQL_U_MISLOGOUT            8
#define SQL_U_NOSALE               9
#define SQL_U_VOIDSALE             10

// adjustment action values
#define SQL_A_CHANGE               1
#define SQL_A_PAYIN                2
#define SQL_A_PAYOUT               3
#define SQL_A_OPENBAL              4
#define SQL_A_CDEDIT               5
#define SQL_A_SCRAPGOODS           6
#define SQL_A_REFUND               7

// discrepancy action values
#define SQL_D_BLINDBAL             1

// fixed interfaces
#define SQL_IF_NULL                1
#define SQL_IF_TRANSACTION         2
#define SQL_IF_CASHDRAWEREDIT      3
#define SQL_IF_PAYIN               4
#define SQL_IF_PAYOUT              5
#define SQL_IF_TRANSSUMMARY        6
#define SQL_IF_USERSUMMARY         7
#define SQL_IF_XTAPE               8
#define SQL_IF_ZTAPE               9
#define SQL_IF_GOODSRETURN         10
#define SQL_IF_DISCOUNT            11
#define SQL_IF_EPHEMERALIN         12

// defined itemtypes
#define SQL_ITEM_UNKNOWN           1
#define SQL_ITEM_ITEM              2
#define SQL_ITEM_PRICE             3
#define SQL_ITEM_RENTAL            4
#define SQL_ITEM_RETURN            5
#define SQL_ITEM_LAYBY             6

// defined paytypes (<32)
#define SQL_PAY_CASH               1
#define SQL_PAY_CREDIT             2
#define SQL_PAY_CHEQUE             3
#define SQL_PAY_SMARTCARD          4
#define SQL_PAY_CREDITRETURN       5
#define SQL_PAY_CREDITSLIP         6
#define SQL_PAY_GIFTVOUCHER        7
#define SQL_PAY_TPVOUCHER          8
#define SQL_PAY_TPCOUPON           9
#define SQL_PAY_INTCOUPON          10
#define SQL_PAY_LUNCHSTAMP         11
#define SQL_PAY_INHOUSECHARGE      12
#define SQL_PAY_STORECARD          13
#define SQL_PAY_CREDITCB           14
#define SQL_PAY_CHEQUECB           15
#define SQL_PAY_SMARTCARDCB        16

// enum types
#define SQL_ACCOUNT_INCOME                0
#define SQL_ACCOUNT_EXPENSE               1
#define SQL_ACCOUNT_ASSET                 2
#define SQL_ACCOUNT_LIABILITY             3
#define SQL_ACCOUNT_CAPITAL               4

#define SQL_CONTACTDETAILS_HOME           0
#define SQL_CONTACTDETAILS_BUSINESS       1
#define SQL_CONTACTDETAILS_MOBILE         2
#define SQL_CONTACTDETAILS_FAX            3
#define SQL_CONTACTDETAILS_EMAIL          4
#define SQL_CONTACTDETAILS_HTTP           5
#define SQL_CONTACTDETAILS_FTP            6

#define SQL_DELIVERY_RECEIVED             0
#define SQL_DELIVERY_PREPARING            1
#define SQL_DELIVERY_READY                2
#define SQL_DELIVERY_INTRANSIT            3
#define SQL_DELIVERY_DELIVERED            4

#define SQL_DEPOSIT_RENTAL                0
#define SQL_DEPOSIT_LAYBY                 1
#define SQL_DEPOSIT_RETURNABLE            2
#define SQL_DEPOSIT_REDEMPTION            3

#define SQL_DISCOUNT_PRODUCT              0
#define SQL_DISCOUNT_CUSTOMER             1
#define SQL_DISCOUNT_USER                 2

#define SQL_DISCREETDISCOUNT_PRODUCT      0
#define SQL_DISCREETDISCOUNT_TRANSACTION  1

#define SQL_PLU_EAN_13                    0
#define SQL_PLU_EAN_8                     1
#define SQL_PLU_UPC_A                     2
#define SQL_PLU_UPC_E                     3
#define SQL_PLU_ISBN                      4
#define SQL_PLU_EAN_13W                   5
#define SQL_PLU_EAN_13Q                   6
#define SQL_PLU_EAN_13P                   7
#define SQL_PLU_EAN_13I                   8
#define SQL_PLU_BH_SC6                    9

#define SQL_ERRORLOG_INFO                 0
#define SQL_ERRORLOG_WARNING              1
#define SQL_ERRORLOG_ERROR                2
#define SQL_ERRORLOG_CRITICAL             3

#define SQL_GOODSTRANSFER_CREATED         0
#define SQL_GOODSTRANSFER_AWAITINDISPATCH 1
#define SQL_GOODSTRANSFER_DISPATCHED      2
#define SQL_GOODSTRANSFER_INTRANSIT       3
#define SQL_GOODSTRANSFER_DELIVERED       4
   
#define SQL_IMAGEDATA_PERSON              0
#define SQL_IMAGEDATA_PRODUCT             1

#define SQL_ITEMFLAGS_MSG                 0
#define SQL_ITEMFLAGS_AUTH                1
#define SQL_ITEMFLAGS_RECORD              2

#define SQL_LABEL_ITEM                    0
#define SQL_LABEL_SHELF                   1
#define SQL_LABEL_RX                      2

#define SQL_LOGINMETHOD_DATA              0
#define SQL_LOGINMETHOD_PTR               1
#define SQL_LOGINMETHOD_PAIR              2

#define SQL_MARGINCOLLECTION_SITE         0
#define SQL_MARGINCOLLECTION_SITEGROUP    1

#define SQL_MISMENU_MENU                  0
#define SQL_MISMENU_ITEM                  1
#define SQL_MISMENU_TABBBED               2

#define SQL_PRESCRIPTION_GENERATED        0
#define SQL_PRESCRIPTION_FILLED           1
#define SQL_PRESCRIPTION_READY            2
#define SQL_PRESCRIPTION_COLLECTED        3
#define SQL_PRESCRIPTION_CLOSED           4

#define SQL_PRODTARGET_DAY                0
#define SQL_PRODTARGET_WEEK               1
#define SQL_PRODTARGET_MONTH              2
#define SQL_PRODTARGET_QUARTER            3
#define SQL_PRODTARGET_YEAR               4

#define SQL_PRODTARGET_QUANTITY           0
#define SQL_PRODTARGET_SALES              1

#define SQL_PROMOTION_PRICEABSOLUTE       0
#define SQL_PROMOTION_PRICEINCREMENTAL    1
#define SQL_PROMOTION_PRICEMARGIN         2
#define SQL_PROMOTION_ITEMABSOLUTE        3
#define SQL_PROMOTION_ITEMINCREMENTAL     4
#define SQL_PROMOTION_ITEMMARGIN          5

#define SQL_RETURN_TRANSACTION            0
#define SQL_RETURN_TRANSITEM              1
#define SQL_RETURN_STOCK                  0
#define SQL_RETURN_VENDOR                 2
#define SQL_RETURN_SCRAP                  3

#define SQL_SETUP_NONE                    0
#define SQL_SETUP_DIRECT                  1
#define SQL_SETUP_PASSIVE                 2
#define SQL_SETUP_ACTIVE                  3

#define SQL_STORECARD_OK                  0
#define SQL_STORECARD_VERIFY              1
#define SQL_STORECARD_LIMIT               2
#define SQL_STORECARD_DENIED              3
#define SQL_STORECARD_SEIZE               4

#define SQL_SUPPLIER_MANUFACTURER         0
#define SQL_SUPPLIER_VENDOR               1

#define SQL_TRANSTYPE_PRICE               0
#define SQL_TRANSTYPE_DISCOUNT            1
#define SQL_TRANSTYPE_PROMO               2
#define SQL_TRANSTYPE_CUSTOMER            3

#define SQL_VOUCHER_AMOUNT                0
#define SQL_VOUCHER_MARGIN                1
#define SQL_VOUCHER_ITEM                  2

// in file order, inserts to top, as these cause the most "portable" problems...
#ifdef  DB_USE_MYSQL
#define DB_USE_MYSQL41
#include "bhmysql.h"
#define sqlq_qry1   "insert into postlog values(0, '%d', '%d', now(),'')"
#define sqlq_qry3   "insert into posts values(0, '', '', '', mac='%s')"
#define sqlq_qry18  "insert into postlog values(0, '%d', '%d', now(), '%d')"               
#define sqlq_qry19  "insert into employeelog values(0, '%d', '%d', now())"
#define sqlq_qry90  "insert into createmod values (0, now(), now(),%d, %d)"
#define sqlq_qry93  "insert into stocktake_products values(0,%s,'0','%d')"
#define sqlq_qry116 "insert into discrepancy values(0,'',now(),'%s','%d','%d','%0.2f','')"
#define sqlq_qry120 "insert into adjustment values(0,'',now(), '%s', '%d','%d','%0.2f', '')"
#define sqlq_qry70  "lock tables transaction write"
#define sqlq_qry73  "insert into transaction values ()"
#define sqlq_qry77  "unlock tables"
//v1.2.3 additions
#define sqlq_qry147 "insert into address values(0,'%d','%d','%s','%s','%s','%s','%s','%s','%d')"
#define sqlq_qry148 "insert into contacts values(0,0,0,0,'%d','%d','%d','%s','%s','%s','%s','%s','%s','%s','%s')"
#define sqlq_qry149 "insert into contactdetails values(0, '%d','%d','%s')"
#define sqlq_qry150 "insert into chargeaccount values(0,'%d','%d','%d','%f','%s','%d','%s','%s','%s','%s','%s','%d','%d','%d','%s')"
#define sqlq_qry151 "insert into customer values(0,'%d','%d','%d','%d','%d','%d','%d','%s')"
#define sqlq_qry152 "update contactdetails set contactdetailsid='%d'"
// v1.9.9 additions
#define sqlq_qry163  "lock tables ledgerentry write"

#define sqlq_qry2   "select * from posts where mac='%s'"
#define sqlq_qry4   "select deptid, localeid, currencyid from groups where groupid='%d'"
#define sqlq_qry5   "select siteid, localeid, currencyid from departments where deptid='%d'"
#define sqlq_qry6   "select localeid, currencyid from sites where siteid='%d'"
#define sqlq_qry7   "select monetaryunitsid, bigname, smallname from currency where id='%d'"
#define sqlq_qry8   "select * from monetaryunits where muid='%d' order by value"
#define sqlq_qry9   "select id from taxrate where onmenu='Y'"
#define sqlq_qry10  "select id from pqname where onmenu = 'Y'"
#define sqlq_qry12  "select * from logintypes where loginmethodid = %d and ident = '%s'"
#define sqlq_qry13  "select * from logintypes where loginmethodid = %d and data = '%s'"
#define sqlq_qry14  "select * from loginmethod where id = '%d'"
#define sqlq_qry15  "select * from users where id = %d"
#define sqlq_qry16  "select fname, lname from employee where employeeid='%d'"
#define sqlq_qry17  "select distinct userauth.interfaceid, authority.* from authority, userauth, postinterface where \
					      authority.id = userauth.authid and userauth.userid = %d and userauth.loginmethodid = %d \
					      and userauth.interfaceid = postinterface.interfaceid and postinterface.postid = %d"
#define sqlq_qry20  "select now()"
#define sqlq_qry21  "select stamper from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d' limit 1"
#define sqlq_qry22  "select * from sites"
#define sqlq_qry23  "select * from sites where active='Y'"
#define sqlq_qry24  "select * from departments where siteid='%d'"
#define sqlq_qry25  "select * from departments where siteid='%d' and active='Y'"
#define sqlq_qry26  "select * from sites where siteid='%d'"
#define sqlq_qry27  "select * from departments"
#define sqlq_qry28  "select * from departments where active='Y'"
#define sqlq_qry29  "select * from departments where siteid='%d'"
#define sqlq_qry30  "select * from departments where siteid='%d' and active='Y'"
#define sqlq_qry31  "select * from groups where deptid='%d'"
#define sqlq_qry32  "select * from groups where deptid='%d' and active='Y'"
#define sqlq_qry33  "select * from departments where deptid='%d'"
#define sqlq_qry34  "select * from groups"
#define sqlq_qry35  "select * from groups where active='Y'"
#define sqlq_qry36  "select * from groups where deptid='%d'"
#define sqlq_qry37  "select * from groups where deptid='%d' and active='Y'"
#define sqlq_qry38  "select * from posts where groupid='%d'"
#define sqlq_qry39  "select * from posts where groupid='%d' and active='Y'"
#define sqlq_qry40  "select * from groups where groupid='%d'"
#define sqlq_qry41  "select * from posts"
#define sqlq_qry42  "select * from posts where active='Y'"
#define sqlq_qry43  "select * from posts where groupid='%d'"
#define sqlq_qry44  "select * from posts where groupid='%d' and active='Y'"
#define sqlq_qry45  "select * from posts where postid='%d'"
#define sqlq_qry46  "select count(*) from postlog where  (stamper between '%s' and '%s') and   actionid='%d' and postid='%d'"
#define sqlq_qry47  "select count(*) from transaction where (enteredat between '%s' and '%s') and enteredstation='%s'"
#define sqlq_qry48  "select count(*) from transactionitems where (enteredat between '%s' and '%s') and enteredstation='%s'"
#define sqlq_qry49  "select count(*) from postlog where (stamper between '%s' and '%s') and actionid='%d' and postid='%d'"
#define sqlq_qry50  "select count(*) from postlog where (stamper between '%s' and '%s') and actionid='%d' and postid='%d'"
#define sqlq_qry51  "select count(*), sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry52  "select count(*),sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry53  "select count(*), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and enteredstation='%s'"
#define sqlq_qry54  "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='%d' and enteredstation='%s'"
#define sqlq_qry55  "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='%d' and enteredstation='%s'"
#define sqlq_qry56  "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='%d' and enteredstation='%s'"
#define sqlq_qry57  "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype>'3' and enteredstation='%s'"
#define sqlq_qry58  "select distinct count(enteredby) from transaction where (enteredat between '%s' and '%s')"
#define sqlq_qry59  "select distinct employeeid from employeelog where (stamper between '%s' and '%s') and actionid='%d'"
#define sqlq_qry60  "select count(*) from transaction where (enteredat between '%s' and '%s') and enteredstation='%s' and enteredby='%d'"
#define sqlq_qry61  "select count(*) from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d'"
#define sqlq_qry62  "select count(*) from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d'"
#define sqlq_qry63  "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and userid='%d'"
#define sqlq_qry64  "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and userid='%d'"
#define sqlq_qry65  "select sum(amount) from paymentitem where (enteredat between '%s' and '%s') and enteredby='%d'"
#define sqlq_qry66  "select count(*) from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d'"
#define sqlq_qry67  "select stamper from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d' order by stamper desc limit 1"         
#define sqlq_qry68  "select stamper from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d' limit 1"
#define sqlq_qry69  "select time_to_sec(stamper) from employeelog where (stamper between '%s' and '%s') and (actionid='%d' or actionid='%d') and employeeid='%d' desc"
#define sqlq_qry71  "select transactionid from transaction where transactionid='%d'"
#define sqlq_qry72  "select accountnumber from salepricename where id='%d'"
#define sqlq_qry74  "update transaction set transactionid='%d' where id='%d'"
#define sqlq_qry75  "update transaction set linkid='%d' where transactionid='%d'"
#define sqlq_qry76  "update transaction set accountid='%d' where transactionid='%d'"
#define sqlq_qry79  "select * from ephemeral_plu where plu='%s'"
#define sqlq_qry80  "select * from itemflags where flagid='%d'"
#define sqlq_qry81  "select * from plu_cache where plu='%s' and nameid='%d'"
#define sqlq_qry82  "select * from plu_cache where plu='%s' and nameid='1'"
#define sqlq_qry83  "select * from u_plu where plu='%s'"
#define sqlq_qry84  "select margin from discount where targetid= '%d' and type='product'"
#define sqlq_qry85  "select * from promotion where promotionid = '%d' and to_days(enddate) < to_days(now()"
#define sqlq_qry86  "select id, accountid, rate  from taxrate where onmenu = 'Y'"
#define sqlq_qry87  "select name from account where accountnumber = '%s'"
#define sqlq_qry88  "select id, name, accountid from pqname where onmenu = 'Y'"
#define sqlq_qry89  "select * from returntype where active = 'Y'"
#define sqlq_qry91  "select currentstock from stocktake_products where plu = '%s'"
#define sqlq_qry92  "update stocktake_products set currentstock='%d' where plu = '%s'"
#define sqlq_qry94  "update delivery set status='%d' set delivererid='%d' where id=%d"
#define sqlq_qry95  "select * from delivery where status='ready'"
#define sqlq_qry96  "select id, contactid, addressid from customer where id='%d'"
#define sqlq_qry97  "select firstname, lastname from contacts where contactid='%d'"
#define sqlq_qry98  "select address1, city, postcode from address where id='%d'"
#define sqlq_qry99  "select * from delivery where status='%d'"
#define sqlq_qry103 "select * from rental where returned='N'"
#define sqlq_qry104 "select contactid, addressid from customer where id='%d'"
#define sqlq_qry106 "select id from customer where contactid='%d'"
#define sqlq_qry108 "select data from contactdetails where contactdetailsid='%d'"
#define sqlq_qry109 "select contactdetailsid from contactdetails where data='%s'"
#define sqlq_qry111 "select monetaryunitsid from currency where id='%d'"
#define sqlq_qry113 "select prescription.cmid, prescription.prescriptionid, prescription.prescriptionnumber, \
			prescription.status, ephemeral_plu.unitprice from ephemeral_plu, prescription where \
			ephemeral_plu.refid=prescription.prescriptionid and \
			ephemeral_plu.plu='%s'"
#define sqlq_qry114 "select prescriptionitems.quantity from prescriptionitems where prescriptionitems.prescriptionid='%d'"
#define sqlq_qry115 "update prescription set status='ready', readiedat=now(), readiedbyid=uid where id='%d'"
#define sqlq_qry123 "select id,name,description from menu where id='%d'"
#define sqlq_qry124 "select id,name,description,rectext,printeridprice from menuitem where menuid='%d'"
#define sqlq_qry125 "select id,name,rectext from menuitemoptions where menuitemid='%d'"
#define sqlq_qry129 "select createdby from createmod where id='%d'"
#define sqlq_qry130 "select modifiedby from createmod where id='%d'"
#define sqlq_qry131 "select createdwhen from createmod where id='%d'"
#define sqlq_qry132 "select modifieddate from createmod where id='%d'"
#define sqlq_qry133 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry134 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry135 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry136 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry137 "select sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='1' and amount>'0.0' and enteredstation='%s'"
#define sqlq_qry138 "select sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='1' and amount<'0.0' and enteredstation='%s'"
#define sqlq_qry139 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry140 "select monetaryunitsid from currency where id='%d'"
#define sqlq_qry142 "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='%d' and enteredstation='%d'"
#define sqlq_qry143 "select * from logintypes where loginmethodid = %d and ident = '%s' and data = '%s'"
#define sqlq_qry144 "select distinct count(enteredby) from transaction where (enteredat between '%s' and '%s')"
#define sqlq_qry145 "select last_insert_id()"
#define sqlq_qry146 "unlock tables"
// v1.2.3 additions
#define sqlq_qry153 "select id, creditlimit from chargeaccount where id='%d'"
#define sqlq_qry154 "select sum(amount) from chargeitem where chargeaccountid='%d' and amount > 0.0"

// v2.0.0 additions
#define sqlq_qry155 "select * from schedule where (month='%d' or month='-1' or month='0') and \
((day='%d' or or day='-1' or day='0') or (dayofweek='%d' or dayofweek='-1')) and \
(hour='%d' or hour='-1' or hour='0') and (minute='%d' or minute='-1' or minute='0')"
#define sqlq_qry156 "select * from menu where current='Y'"
#define sqlq_qry157 "select * from menuheading where menuid='%d'"
#define sqlq_qry158 "select * from menuitem where menuid='%d' and available='Y'"
#define sqlq_qry159 "select reffile from imagedata where id='%d'"
#define sqlq_qry160  "select contactid from employee where id='%d'"
#define sqlq_qry161  "select firstname, lastname from contacts where id='%d'"
#define sqlq_qry162  "select * from paymenttype where bacceptable='Y'"

#define transq_qry1  "insert into delivery values ('','%d','0','%d','%d','%d','%0.2f')"
#define transq_qry2  "insert into paymentitem values ('','0','%d','%d','%f',now(),'%d','%s','0')"
#define transq_qry6  "insert into transtype values('','%d','price','%d')"
#define transq_qry12 "insert into u_plu values(0,now(),'%s','0','%s','%f','0.00','%f')"
#define transq_qry16 "insert into transactionitems values ('','%d',now(),'%d','%s','%d','%s','%d')"
#define transq_qry17 "insert into layby values ('','','','%d','%d','0',now(),'','%f','%f')"
#define transq_qry19 "insert into transaction values ('','','%d','','','','','','','rental','','','','','','%d')"
#define transq_qry22 "insert into rental values ('','%d','%d','%d', now(),'%d','N','0','')"
#define transq_qry23 "insert into transaction values ('','','','','','','','','item returns','','','','','%d')"
#define transq_qry27 "insert into return values ('','%d','%d','%d','','','%d')"
#define transq_qry28 "insert into transaction values ('','','%d','','','','','','','layby','','','','','','%d')"
#define transq_qry30 "select last_insert_id()"
#define transq_qry31 "select last_insert_id()"
#define transq_qry32 "select last_insert_id()"
//v1.2.3 additions
#define transq_qry33 "insert into chargeitem values('','%d','%d','%d',now(),'%f')"

#define transq_qry3  "update paymentitem set payid='%d' where transid='%d'"
#define transq_qry4  "update transaction set open='N', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='%d', paymenttypeid='%d' where transactionid='%d'"
#define transq_qry5  "update transaction set open='Y', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='19' where transactionid='%d'"
#define transq_qry7  "select id,open from transaction where transactionid='%d' and open='Y'"
#define transq_qry8  "delete from transaction where id='%d'"
#define transq_qry9  "select open from transaction where transactionid='%d'"
#define transq_qry10 "select id from transaction where transactionid='%d'"
#define transq_qry11 "update transaction set open='Y' where transactionid='%d'"
#define transq_qry13 "select transactionid, dateplaced, total, paid from layby where customerid='%d'"
#define transq_qry14 "select id from transactionitems where transactionid='%d'"
#define transq_qry15 "select id from paymentitems where transid='%d'"
#define transq_qry18 "select linkid, status from transaction where transactionid='%d'"
#define transq_qry20 "update transaction set transactionid='%d', open='Y', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='19' where id='%d'"
#define transq_qry21 "select * from transactionitems where transactionid='%d'"
#define transq_qry24 "update transaction set transactionid='%d', open='N', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='0' where id='%d'"
#define transq_qry25 "update transaction set open='N', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='19' where transactionid='%d'"
#define transq_qry26 "select * from paymentitem where transid='%d'"
#define transq_qry29 "update transaction set transactionid='%d', open='Y', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='20', closedat=now() where id='%d'"
//v1.2.3 additions
#define transq_qry34 "select chargeaccountid from customer where id='%d'"
#define transq_qry35 "update transaction set open='N' where id='%d'"
// v1.9.9 additions
#define transq_qry36 "select sum(amount) from paymentitem where transid='%d'"
#define transq_qry37 "insert into ledgerentry values(0,'%d','%d','%d',date(now()),'%s','%s','%f','%s','%d')"
#endif

#ifdef DB_USE_MYSQL41
#undef  sqlq_qry70
#undef  sqlq_qry77
#undef  sqlq_qry146
#define sqlq_qry70  "START TRANSACTION"
#define sqlq_qry77  "COMMIT"
#define sqlq_qry146 "ROLLBACK"
#endif

#ifdef DB_USE_POSTGRE
#include "bhpgsql.h"
#define sqlq_qry1   "insert into postlog values(nextval('postlog_id_seq'), '%d', '%d', now(),'')"
#define sqlq_qry3   "insert into posts values(nextval('posts_id_seq'), '', '', '', mac='%s')"
#define sqlq_qry11  "insert into postlog values(nextval('postlog_id_seq'), '%d', '%d', now(),'')"
#define sqlq_qry18  "insert into postlog values(nextval('postlog_id_seq'), '%d', '%d', now(), '%d')"               
#define sqlq_qry19  "insert into employeelog values(nextval('employeelog_id_seq'), '%d', '%d', now())"
#define sqlq_qry70  "begin"
#define sqlq_qry73  "insert into transaction values (nextval('transaction_id_seq'),0,now(),0,'',0,0,'','','Y','N','Y',0,0)"
#define sqlq_qry74  "update transaction set transactionid='%d' where id='%d'"
#define sqlq_qry75  "update transaction set linkid='%d' where transactionid='%d'"
#define sqlq_qry76  "update transaction set accountid='%d' where transactionid='%d'"
#define sqlq_qry77  "commit"
//v1.2.3 additions
#define sqlq_qry147 "insert into address values(nextval('address_id_seq'),'%s','%s','%s','%s','%s','%s','%s')"
#define sqlq_qry148 "insert into contacts values(nextval('contact_id_seq'),0,'%d','%d','%d','%d','%s','%s','%s','%s','%s','%s','%d' '%s','%s','%d')"
#define sqlq_qry149 "insert into contactdetails values(nextval('contactdetails_id_seq'), '%d','%d','%s')"
#define sqlq_qry150 "insert into chargeaccount values(nextval('chargeaccount_id_seq'),'%d','%d','%d','%f','%s','%s','%s','%s','%s','%s','%d','%d','%d','%s')"
#define sqlq_qry151 "insert into customer values(nextval('customer_id_seq'),0,'%d','%d','%d','%d','%d','%d','%s')"
#define sqlq_qry152 "update contactdetails set contactdetailsid='%d'"
// v1.9.9 additions
#define sqlq_qry163  "lock tables ledgerentry write"

#define sqlq_qry90  "insert into createmod values(nextval('createmod_id_seq'), now(), now(),%d, %d)"
#define sqlq_qry92  "update stocktake_products set currentstock='%d' where plu = '%s'"
#define sqlq_qry93  "insert into stocktake_products values(nextval('stocktake_products_id_seq'),%s,'0','%d')"
#define sqlq_qry94  "update delivery set status='%d' set delivererid='%d' where id=%d"
#define sqlq_qry115 "update prescription set status='ready', readiedat=now(), readiedbyid=uid where id='%d'"
#define sqlq_qry116 "insert into discrepancy values(nextval('discrepancy_id_seq'),'',now(),'%s','%d','%d','%0.2f','')"
#define sqlq_qry117 "insert into employeelog values(nextval('employeelog_id_seq'), '%d', '%d', now())"
#define sqlq_qry118 "insert into employeelog values(nextval('employeelog_id_seq'), '%d', '%d', now())"
#define sqlq_qry119 "insert into employeelog values(nextval('employeelog_id_seq'), '%d', '%d', now())"
#define sqlq_qry120 "insert into adjustment values(nextval('adjustment_id_seq'),'',now(), '%s', '%d','%d','%0.2f', '')"
#define sqlq_qry121 "insert into adjustment values(nextval('adjustment_id_seq'),'',now(), '%s', '%d','%d','%0.2f', '')"
#define sqlq_qry122 "insert into adjustment values(nextval('adjustment_id_seq'),'',now(), '%s', '%d','%d','%0.2f', '')"
#define sqlq_qry146 "rollback"
#define sqlq_qry145 "select currval('transaction_id_seq')"

#define sqlq_qry2   "select * from posts where mac='%s'"
#define sqlq_qry4   "select deptid, localeid, currencyid from groups where groupid='%d'"
#define sqlq_qry5   "select siteid, localeid, currencyid from departments where deptid='%d'"
#define sqlq_qry6   "select localeid, currencyid from sites where siteid='%d'"
#define sqlq_qry7   "select monetaryunitsid, bigname, smallname from currency where id='%d'"
#define sqlq_qry8   "select * from monetaryunits where muid='%d' order by value"
#define sqlq_qry9   "select id from taxrate where onmenu='Y'"
#define sqlq_qry10  "select id from pqname where onmenu = 'Y'"
#define sqlq_qry12  "select * from logintypes where loginmethodid = %d and ident = '%s'"
#define sqlq_qry13  "select * from logintypes where loginmethodid = %d and data = '%s'"
#define sqlq_qry14  "select * from loginmethod where id = '%d'"
#define sqlq_qry15  "select * from users where id = %d"
#define sqlq_qry16  "select fname, lname from employee where employeeid='%d'"
#define sqlq_qry17  "select distinct userauth.interfaceid, authority.* from authority, userauth, postinterface where \
					      authority.id = userauth.authid and userauth.userid = %d and userauth.loginmethodid = %d \
					      and userauth.interfaceid = postinterface.interfaceid and postinterface.postid = %d"
#define sqlq_qry20  "select substr(now()::date + now()::time, 0, 20)"
#define sqlq_qry21  "select stamper from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d' limit 1"
#define sqlq_qry22  "select * from sites"
#define sqlq_qry23  "select * from sites where active='Y'"
#define sqlq_qry24  "select * from departments where siteid='%d'"
#define sqlq_qry25  "select * from departments where siteid='%d' and active='Y'"
#define sqlq_qry26  "select * from sites where siteid='%d'"
#define sqlq_qry27  "select * from departments"
#define sqlq_qry28  "select * from departments where active='Y'"
#define sqlq_qry29  "select * from departments where siteid='%d'"
#define sqlq_qry30  "select * from departments where siteid='%d' and active='Y'"
#define sqlq_qry31  "select * from groups where deptid='%d'"
#define sqlq_qry32  "select * from groups where deptid='%d' and active='Y'"
#define sqlq_qry33  "select * from departments where deptid='%d'"
#define sqlq_qry34  "select * from groups"
#define sqlq_qry35  "select * from groups where active='Y'"
#define sqlq_qry36  "select * from groups where deptid='%d'"
#define sqlq_qry37  "select * from groups where deptid='%d' and active='Y'"
#define sqlq_qry38  "select * from posts where groupid='%d'"
#define sqlq_qry39  "select * from posts where groupid='%d' and active='Y'"
#define sqlq_qry40  "select * from groups where groupid='%d'"
#define sqlq_qry41  "select * from posts"
#define sqlq_qry42  "select * from posts where active='Y'"
#define sqlq_qry43  "select * from posts where groupid='%d'"
#define sqlq_qry44  "select * from posts where groupid='%d' and active='Y'"
#define sqlq_qry45  "select * from posts where postid='%d'"
#define sqlq_qry46  "select count(*) from postlog where  (stamper between '%s' and '%s') and   actionid='%d' and postid='%d'"
#define sqlq_qry47  "select count(*) from transaction where (enteredat between '%s' and '%s') and enteredstation='%s'"
#define sqlq_qry48  "select count(*) from transactionitems where (enteredat between '%s' and '%s') and enteredstation='%s'"
#define sqlq_qry49  "select count(*) from postlog where (stamper between '%s' and '%s') and actionid='%d' and postid='%d'"
#define sqlq_qry50  "select count(*) from postlog where (stamper between '%s' and '%s') and actionid='%d' and postid='%d'"
#define sqlq_qry51  "select count(*), sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry52  "select count(*),sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry53  "select count(*), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and enteredstation='%s'"
#define sqlq_qry54  "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='%d' and enteredstation='%s'"
#define sqlq_qry55  "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='%d' and enteredstation='%s'"
#define sqlq_qry56  "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='%d' and enteredstation='%s'"
#define sqlq_qry57  "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype>'3' and enteredstation='%s'"
#define sqlq_qry58  "select distinct count(enteredby) from transaction where (enteredat between '%s' and '%s')"
#define sqlq_qry59  "select distinct employeeid from employeelog where (stamper between '%s' and '%s') and actionid='%d'"
#define sqlq_qry60  "select count(*) from transaction where (enteredat between '%s' and '%s') and enteredstation='%s' and enteredby='%d'"
#define sqlq_qry61  "select count(*) from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d'"
#define sqlq_qry62  "select count(*) from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d'"
#define sqlq_qry63  "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and userid='%d'"
#define sqlq_qry64  "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and userid='%d'"
#define sqlq_qry65  "select sum(amount) from paymentitem where (enteredat between '%s' and '%s') and enteredby='%d'"
#define sqlq_qry66  "select count(*) from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d'"
#define sqlq_qry67  "select stamper from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d' order by stamper desc limit 1"         
#define sqlq_qry68  "select stamper from employeelog where (stamper between '%s' and '%s') and actionid='%d' and employeeid='%d' limit 1"
#define sqlq_qry69  "select time_to_sec(stamper) from employeelog where (stamper between '%s' and '%s') and (actionid='%d' or actionid='%d') and employeeid='%d' desc"
#define sqlq_qry71  "select transactionid from transaction where transactionid='%d'"
#define sqlq_qry72  "select accountnumber from salepricename where id='%d'"
#define sqlq_qry79  "select * from ephemeral_plu where plu='%s'"
#define sqlq_qry80  "select * from itemflags where flagid='%d'"
#define sqlq_qry81  "select * from plu_cache where plu='%s' and nameid='%d'"
#define sqlq_qry82  "select * from plu_cache where plu='%s' and nameid='1'"
#define sqlq_qry83  "select * from u_plu where plu='%s'"
#define sqlq_qry84  "select margin from discount where targetid= '%d' and type='product'"
#define sqlq_qry85  "select * from promotion where promotionid = '%d' and to_days(enddate) < to_days(now()"
#define sqlq_qry86  "select id, accountid, rate  from taxrate where onmenu = 'Y'"
#define sqlq_qry87  "select name from account where accountnumber = '%s'"
#define sqlq_qry88  "select id, name, accountid from pqname where onmenu = 'Y'"
#define sqlq_qry89  "select * from returntype where active = 'Y'"
#define sqlq_qry91  "select currentstock from stocktake_products where plu = '%s'"
#define sqlq_qry95  "select * from delivery where status='ready'"
#define sqlq_qry96  "select id, contactid, addressid from customer where id='%d'"
#define sqlq_qry97  "select firstname, lastname from contacts where contactid='%d'"
#define sqlq_qry98  "select address1, city, postcode from address where id='%d'"
#define sqlq_qry99  "select * from delivery where status='%d'"
#define sqlq_qry103 "select * from rental where returned='N'"
#define sqlq_qry104 "select contactid, addressid from customer where id='%d'"
#define sqlq_qry106 "select id from customer where contactid='%d'"
#define sqlq_qry108 "select data from contactdetails where contactdetailsid='%d'"
#define sqlq_qry109 "select contactdetailsid from contactdetails where data='%s'"
#define sqlq_qry111 "select monetaryunitsid from currency where id='%d'"
#define sqlq_qry113 "select prescription.cmid, prescription.prescriptionid, prescription.prescriptionnumber, \
			prescription.status, ephemeral_plu.unitprice from ephemeral_plu, prescription where \
			ephemeral_plu.refid=prescription.prescriptionid and \
			ephemeral_plu.plu='%s'"
#define sqlq_qry114 "select prescriptionitems.quantity from prescriptionitems where prescriptionitems.prescriptionid='%d'"
#define sqlq_qry123 "select id,name,description from menu where id='%d'"
#define sqlq_qry124 "select id,name,description,rectext,printeridprice from menuitem where menuid='%d'"
#define sqlq_qry125 "select id,name,rectext from menuitemoptions where menuitemid='%d'"
#define sqlq_qry129 "select createdby from createmod where id='%d'"
#define sqlq_qry130 "select modifiedby from createmod where id='%d'"
#define sqlq_qry131 "select createdwhen from createmod where id='%d'"
#define sqlq_qry132 "select modifieddate from createmod where id='%d'"
#define sqlq_qry133 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry134 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry135 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry136 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry137 "select sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='1' and amount>'0.0' and enteredstation='%s'"
#define sqlq_qry138 "select sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='1' and amount<'0.0' and enteredstation='%s'"
#define sqlq_qry139 "select sum(amount) from adjustment where (enteredat between '%s' and '%s') and typeid='%d' and stationid='%s'"
#define sqlq_qry140 "select monetaryunitsid from currency where id='%d'"
#define sqlq_qry142 "select count(id), sum(amount) from paymentitem where (enteredat between '%s' and '%s') and paytype='%d' and enteredstation='%d'"
#define sqlq_qry143 "select * from logintypes where loginmethodid = %d and ident = '%s' and data = '%s'"
#define sqlq_qry144 "select distinct count(enteredby) from transaction where (enteredat between '%s' and '%s')"
// v1.2.3 additions
#define sqlq_qry153 "select id, creditlimit from chargeaccount where id='%d'"
#define sqlq_qry154 "select sum(amount) from chargeitem where chargeaccountid='%d' and amount > 0.0"
// v2.0.0 additions
#define sqlq_qry155 "select * from schedule where (month='%d' or month='-1' or month='0') and \
((day='%d' or or day='-1' or day='0') or (dayofweek='%d' or dayofweek='-1')) and \
(hour='%d' or hour='-1' or hour='0') and (minute='%d' or minute='-1' or minute='0')"
#define sqlq_qry156 "select * from menu where current='Y'"
#define sqlq_qry157 "select * from menuheading where menuid='%d'"
#define sqlq_qry158 "select * from menuitem where menuid='%d' and available='Y'"
#define sqlq_qry159 "select reffile from imagedata where id='%d'"
#define sqlq_qry160  "select contactid from employee where id='%d'"
#define sqlq_qry161  "select firstname, lastname from contacts where id='%d'"
#define sqlq_qry162  "select * from paymenttype where bacceptable='Y'"

#define transq_qry1  "insert into delivery values (nextval('delivery_id_seq'),'%d','0','%d','%d','%d','%0.2f')"
#define transq_qry2  "insert into paymentitem values (nextval('paymentitem_id_seq'),'0','%d','%d','%f',now(),'%d','%s','0')"
#define transq_qry6  "insert into transtype values(nextval('transtype_id_seq'),'%d','price','%d')"
#define transq_qry12 "insert into u_plu values(nextval('u_plu_id_seq'),now(),'%s','0','%s','%f','0.00','%f')"
#define transq_qry16 "insert into transactionitems values (nextval('transactionitems_id_seq'),'%d',now(),'%d','%s','%d','%s','%d')"
#define transq_qry17 "insert into layby values (nextval('layby_id_seq'),'','','%d','%d','0',now(),'','%f','%f')"
#define transq_qry19 "insert into transaction values (nextval('transaction_id_seq'),'','%d','','','','','','','rental','','','','','','%d')"
#define transq_qry22 "insert into rental values (nextval('rental_id_seq'),'%d','%d','%d', now(),'%d','N','0','')"
#define transq_qry23 "insert into transaction values (nextval('transaction_id_seq'),'','','','','','','','item returns','','','','','%d')"
#define transq_qry27 "insert into return values (nextval('return_id_seq'),'%d','%d','%d','','','%d')"
#define transq_qry28 "insert into transaction values (nextval('transaction_id_seq'),'','%d','','','','','','','layby','','','','','','%d')"
#define transq_qry30 "select currval('paymentitem_id_seq')"
#define transq_qry31 "select currval('createmod_id_seq')"
#define transq_qry32 "select currval('transactionitems_id_seq')"
//v1.2.3 additions
#define transq_qry33 "insert into chargeitem values(nextval('chargeaccountitem_id_seq'),'%d','%d','%d',now(),'%f')"

#define transq_qry3  "update paymentitem set payid='%d' where transid='%d'"
#define transq_qry4  "update transaction set open='N', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='%d', paymenttypeid='%d' where transactionid='%d'"
#define transq_qry5  "update transaction set open='Y', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='19' where transactionid='%d'"
#define transq_qry7  "select id,open from transaction where transactionid='%d' and open='Y'"
#define transq_qry8  "delete from transaction where id='%d'"
#define transq_qry9  "select open from transaction where transactionid='%d'"
#define transq_qry10 "select id from transaction where transactionid='%d'"
#define transq_qry11 "update transaction set open='Y' where transactionid='%d'"
#define transq_qry13 "select transactionid, dateplaced, total, paid from layby where customerid='%d'"
#define transq_qry14 "select id from transactionitems where transactionid='%d'"
#define transq_qry15 "select id from paymentitems where transid='%d'"
#define transq_qry18 "select linkid, status from transaction where transactionid='%d'"
#define transq_qry20 "update transaction set transactionid='%d', open='Y', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='19' where id='%d'"
#define transq_qry21 "select * from transactionitems where transactionid='%d'"
#define transq_qry24 "update transaction set transactionid='%d', open='N', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='0' where id='%d'"
#define transq_qry25 "update transaction set open='N', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='19' where transactionid='%d'"
#define transq_qry26 "select * from paymentitem where transid='%d'"
#define transq_qry29 "update transaction set transactionid='%d', open='Y', enteredat=now(), enteredby='%d', enteredstation='%s', statusid='20', closedat=now() where id='%d'"
//v1.2.3 additions
#define transq_qry34 "select chargeaccountid from customer where id='%d'"
#define transq_qry35 "update transaction set open='N' where id='%d'"
// v1.9.9 additions
#define transq_qry36 "select sum(amount) from paymentitem where transid='%d'"
#define transq_qry37 "insert into ledgerentry values(0,'%d','%d','%d',date(now()),'%s','%s','%f','%s','%d')"
#endif

#endif   // __BHSQL_VALUES__
